#ifndef __CREDDY_H__
#define __CREDDY_H__

typedef struct _options_t {
    int help;
    int mode;

    // generate options
    char *cn;
    int validity;
} options_t;

#define MODE_GENERATE   1
#define MODE_VERIFY     2
#define MODE_KEYID      3
#define MODE_ATTRIBUTE  4
#define MODE_ROLES      5

// returns true if a name starts with a letter and is otherwise alphanumeric
int clean_name(char *string);

void usage(options_t *opts);
void *xmalloc(size_t len);
char *xstrdup(char *string);

// sub programs
void generate_main(options_t *opts);

#endif /* __CREDDY_H__ */
